#Nuevas líneas de código SQL

#Adición de columna de url de imagen a la tabla producto

ALTER TABLE tproducto ADD COLUMN IMAGE_URL varchar(255) DEFAULT "";

#Vista de tproducto para una selección más limpia y rápida

CREATE VIEW cproducto AS SELECT ID_PRODUCTO, CONCAT(
(SELECT tmarca.NOMBRE FROM tmarca WHERE tmarca.ID_MARCA=tproducto.ID_MARCA), " ",
(SELECT tmodelo.NOMBRE FROM tmodelo WHERE tmodelo.ID_MODELO=tproducto.ID_MODELO), " ",
(SELECT tcolor.NOMBRE FROM tcolor WHERE tcolor.ID_COLOR=tproducto.ID_COLOR), " #", 
(SELECT tnumero.NUMERO FROM tnumero WHERE tnumero.ID_NUMERO=tproducto.ID_NUMERO)) AS "DESCRIPCION",
COSTO, PRECIO, BAJO, EXISTENCIA, TIPO, MODIF_FECHA, MODIF_HORA, DEPARTAMENTO, IMAGE_URL, 

(SELECT GROUP_CONCAT(CONCAT(proarticle.ID_PROVIDER,":",proarticle.EXISTENCIA)) FROM proarticle WHERE proarticle.ID_PRODUCTO LIKE tproducto.ID_PRODUCTO) AS "PROVS",
(SELECT tmarca.NOMBRE FROM tmarca WHERE tmarca.ID_MARCA=tproducto.ID_MARCA) AS "MARCA",
(SELECT tmodelo.NOMBRE FROM tmodelo WHERE tmodelo.ID_MODELO=tproducto.ID_MODELO) AS "MODELO",
(SELECT tcolor.NOMBRE FROM tcolor WHERE tcolor.ID_COLOR=tproducto.ID_COLOR) AS "COLOR",
(SELECT tnumero.NUMERO FROM tnumero WHERE tnumero.ID_NUMERO=tproducto.ID_NUMERO) AS "NUMERO" FROM tproducto;

CREATE VIEW vproducto AS 
SELECT ID_PRODUCTO, DESCRIPCION, COSTO, PRECIO, 
BAJO, (SELECT SUM(proarticle.EXISTENCIA) FROM proarticle 
WHERE proarticle.ID_PRODUCTO=cproducto.ID_PRODUCTO) AS EXISTENCIA, 
TIPO, MODIF_FECHA, MODIF_HORA,
DEPARTAMENTO, IMAGE_URL, CAST(PROVS AS CHAR(255)) AS PROVIDERS, MARCA, MODELO, COLOR,
NUMERO FROM cproducto;


#Adición de columnas de límite de descuento a la tabla de usuarios.

ALTER TABLE tusuario ADD COLUMN TIPO_LIMITE ENUM("porcentaje","cantidad") DEFAULT "porcentaje";
ALTER TABLE tusuario ADD COLUMN LIMITE double default 0;

#Adición de columnas a la tabla de venta
ALTER TABLE TVENTA ADD COLUMN TIPO enum("apartado","venta") default "venta";
ALTER TABLE TVENTA ADD COLUMN ESTADO enum("pagado","liquidado","cambiado","cancelado","abonado") DEFAULT "pagado";
UPDATE tventa SET TIPO="apartado" WHERE ORIGEN=5;
ALTER TABLE tventa DROP COLUMN ORIGEN;

ALTER TABLE tventa ADD COLUMN DESCUENTO DOUBLE DEFAULT 0;
ALTER TABLE tventa ADD COLUMN TIPO_DESCUENTO ENUM("cantidad","porcentaje") DEFAULT "cantidad";


#Arregla la columna boolean de MODO, acomodando correctamente los signos.
ALTER TABLE tusuario ADD COLUMN VIGENTE BOOLEAN DEFAULT false;
UPDATE tusuario SET VIGENTE=true WHERE MODO=0;
ALTER TABLE tusuario DROP COLUMN MODO;
UPDATE tusuario SET NOMBRE="Miguel Angel 2" WHERE ID_USUARIO=13;
ALTER TABLE tusuario ADD COLUMN IMAGE_URL VARCHAR(255);

ALTER TABLE tusuario CHANGE COLUMN DESCRIPCION PASSWORD VARCHAR(255);
UPDATE tusuario SET IMAGE_URL="null";

ALTER TABLE tproveedor ADD COLUMN VIGENTE BOOLEAN default true;

CREATE TABLE tmarca2 (ID_MARCA INT NOT NULL AUTO_INCREMENT, NOMBRE VARCHAR(255), 
PRIMARY KEY(ID_MARCA));

CREATE TABLE tmodelo2 (ID_MODELO INT NOT NULL AUTO_INCREMENT, NOMBRE VARCHAR(100), 
ID_MARCA INT, PRIMARY KEY(ID_MODELO), FOREIGN KEY(ID_MARCA) 
REFERENCES tmarca2(ID_MARCA));

CREATE TABLE tcolor2 (ID_COLOR INT NOT NULL AUTO_INCREMENT, NOMBRE VARCHAR(150), 
PRIMARY KEY(ID_COLOR));

CREATE TABLE tnumero2 (ID_NUMERO INT NOT NULL AUTO_INCREMENT, NUMERO DOUBLE, PRIMARY KEY(ID_NUMERO));


CREATE TABLE `tproducto2` (
  `ID_PRODUCTO` varchar(100) NOT NULL,
  `ID_MARCA` int(11) DEFAULT NULL,
  `ID_MODELO` int(11) DEFAULT NULL,
  `ID_COLOR` int(11) DEFAULT NULL,
  `ID_NUMERO` int(11) DEFAULT NULL,
  `COSTO` double DEFAULT NULL,
  `PRECIO` double DEFAULT NULL,
  `BAJO` double DEFAULT NULL,
  `EXISTENCIA` double DEFAULT NULL,
  `TIPO` enum('DOCENA','UNIDAD') DEFAULT NULL,
  `MODIF_FECHA` date DEFAULT NULL,
  `MODIF_HORA` time DEFAULT NULL,
  `DEPARTAMENTO` varchar(255) DEFAULT NULL,
  `IMAGE_URL` varchar(255) DEFAULT '',
  PRIMARY KEY (`ID_PRODUCTO`),
  FOREIGN KEY (`ID_COLOR`) REFERENCES `tcolor2` (`ID_COLOR`) ON DELETE NO ACTION ON UPDATE NO ACTION,
  FOREIGN KEY (`ID_MARCA`) REFERENCES `tmarca2` (`ID_MARCA`) ON DELETE NO ACTION ON UPDATE NO ACTION,
  FOREIGN KEY (`ID_MODELO`) REFERENCES `tmodelo2` (`ID_MODELO`) ON DELETE NO ACTION ON UPDATE NO ACTION,
  FOREIGN KEY (`ID_NUMERO`) REFERENCES `tnumero2` (`ID_NUMERO`) ON DELETE NO ACTION ON UPDATE NO ACTION
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

CREATE VIEW vproducto2 AS SELECT ID_PRODUCTO, CONCAT(
(SELECT tmarca2.NOMBRE FROM tmarca2 WHERE tmarca2.ID_MARCA=tproducto2.ID_MARCA), " ",
(SELECT tmodelo2.NOMBRE FROM tmodelo2 WHERE tmodelo2.ID_MODELO=tproducto2.ID_MODELO), " ",
(SELECT tcolor2.NOMBRE FROM tcolor2 WHERE tcolor2.ID_COLOR=tproducto2.ID_COLOR), " #", 
(SELECT tnumero2.NUMERO FROM tnumero2 WHERE tnumero2.ID_NUMERO=tproducto2.ID_NUMERO)) AS "DESCRIPCION",
COSTO, PRECIO, BAJO, EXISTENCIA, TIPO, MODIF_FECHA, MODIF_HORA, DEPARTAMENTO, IMAGE_URL,
(SELECT tmarca2.NOMBRE FROM tmarca2 WHERE tmarca2.ID_MARCA=tproducto2.ID_MARCA) AS "MARCA",
(SELECT tmodelo2.NOMBRE FROM tmodelo2 WHERE tmodelo2.ID_MODELO=tproducto2.ID_MODELO) AS "MODELO",
(SELECT tcolor2.NOMBRE FROM tcolor2 WHERE tcolor2.ID_COLOR=tproducto2.ID_COLOR) AS "COLOR",
(SELECT tnumero2.NUMERO FROM tnumero2 WHERE tnumero2.ID_NUMERO=tproducto2.ID_NUMERO) AS "NUMERO" FROM tproducto2;

ALTER TABLE tventa ADD COLUMN ORIGEN ENUM("general","catalogo") DEFAULT "general";